﻿Option Strict On
Imports System.Xml.Linq
Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone

Public Class ImageInfo
    Property imageFileName As WriteableBitmap
    Property recordDate As String
End Class
Partial Public Class DataIchiranPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myMenuItem1 As New MenuItem
    Dim myMenuItem2 As New MenuItem
    Dim myContextMenu As New ContextMenu
    Dim imageName As String
    Dim doc As XElement
    Dim myIndex As Integer
    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("ImageInFrame", "ImageList.xml")
        Using myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
            Using reader As StreamReader = New StreamReader(myStream)
                Dim readXmldoc As String = reader.ReadToEnd
                doc = XElement.Parse(readXmldoc)
                Dim myImageInfo As New List(Of ImageInfo)

                For Each result In From c In doc.Descendants("風景") Select c
                    Dim imageFilePath As String = Path.Combine("ImageInFrame", result.Element("画像名").Value)
                    Dim imageStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                    Using stream As IsolatedStorageFileStream = imageStorage.OpenFile(imageFilePath, FileMode.Open, FileAccess.Read)
                        Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(stream)
                        With myImageInfo
                            .Add(New ImageInfo With {.imageFileName = imageSource,
                                                    .recordDate = result.Attribute("記録日").Value})
                        End With
                        'stream.Close()
                    End Using
                Next
                ListBox1.ItemsSource = myImageInfo
            End Using
        End Using

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        Try
            myIndex = ListBox1.SelectedIndex
            imageName = doc.Descendants("風景")(myIndex).Element("画像名").Value

            Dim menuItemList As New List(Of MenuItem)

            myMenuItem1.Header = "データの削除"
            myMenuItem1.FontSize = 25
            myMenuItem1.FontWeight = FontWeights.Bold

            myMenuItem2.Header = "キャンセル"
            myMenuItem2.Foreground = New SolidColorBrush(Colors.Red)
            myMenuItem2.FontSize = 25
            myMenuItem2.FontWeight = FontWeights.Bold

            menuItemList.Add(myMenuItem1)
            menuItemList.Add(myMenuItem2)

            myContextMenu.ItemsSource = menuItemList
            myContextMenu.Opacity = 0.8

            ContextMenuService.SetContextMenu(ListBox1, myContextMenu)
            myContextMenu.UpdateLayout()
            myContextMenu.IsOpen = True

            RemoveHandler myMenuItem1.Click, AddressOf myMenuItem_Click
            AddHandler myMenuItem1.Click, AddressOf myMenuItem_Click
            AddHandler myMenuItem2.Click, AddressOf myMenuItem_Click
        Catch
            Exit Sub
        End Try
    End Sub

    Private Sub myMenuItem_Click(sender As Object, e As EventArgs)
        Try
            Dim selectHeader = DirectCast(sender, MenuItem).Header

            Select Case selectHeader.ToString
                Case "データの削除"
                    Dim kakunin = MessageBox.Show("このデータを削除しますか？", "削除確認", MessageBoxButton.OKCancel)

                    Select Case kakunin
                        Case MessageBoxResult.OK
                            DeleteData()
                            Exit Select
                        Case Else
                            ListBox1.SelectedIndex = -1
                            Exit Sub
                    End Select
                Case "キャンセル"
                    myContextMenu.IsOpen = False
                    ListBox1.SelectedIndex = -1
                    Exit Select
                Case Else
                    ListBox1.SelectedIndex = -1
                    Exit Select
            End Select
        Catch
            Exit Sub
        End Try

    End Sub


    Sub DeleteData()
        Dim delXml As XElement
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("ImageInFrame", "ImageList.xml")
        If storage.FileExists(filePath) = True Then
            Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
            Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                Dim readXmldoc As String = reader.ReadToEnd
                delXml = XElement.Parse(readXmldoc)
                myStream.Close()
            End Using

            Dim delImage As String = delXml.Descendants("風景")(myIndex).Element("画像名").Value
            Dim delJPGfile As String = Path.Combine("ImageInFrame", delImage)
            If delImage <> String.Empty Then
                storage.DeleteFile(delJPGfile)
            End If

            Dim delElement = delXml.Descendants("風景")(myIndex)
            delElement.Remove()
            Using stream As IsolatedStorageFileStream = New IsolatedStorageFileStream(filePath, FileMode.Create, FileAccess.Write, storage)
                delXml.Save(stream)
            End Using
            MessageBox.Show("データを削除しました。")

            Dim allDeleteQuery = From c In delXml.Descendants("風景") Select c

            If allDeleteQuery.Count <= 0 Then
                storage.DeleteFile(filePath)
                storage.Dispose()
                NavigationService.Navigate(New Uri(String.Format("/MainPage.xaml?date={0}", DateTime.Now.ToShortDateString & DateTime.Now.ToLongTimeString), UriKind.Relative))
                Exit Sub
            End If
            storage.Dispose()
            NavigationService.Navigate(New Uri(String.Format("/DataIchiranPage.xaml?date={0}", DateTime.Now.ToShortDateString & DateTime.Now.ToLongTimeString), UriKind.Relative))

        Else
            storage.Dispose()
            Exit Sub
        End If
    End Sub

    Protected Overrides Sub OnBackKeyPress(e As System.ComponentModel.CancelEventArgs)
        Dim myStackCount = NavigationService.BackStack.Count
        For i As Integer = 0 To myStackCount - 2
            NavigationService.RemoveBackEntry()
        Next
        MyBase.OnBackKeyPress(e)
    End Sub
End Class
