﻿Option Strict On
Imports Microsoft.Devices
Imports System.IO.IsolatedStorage
Imports System.Windows.Media.Imaging
Imports System.IO
Imports System.Xml.Linq
Imports Microsoft.Phone
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub

    Dim bufferValue As Integer = 5119
    Dim myPhotoCamera As PhotoCamera
    Dim imageFileName As String
    Dim recordDate As String


    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("ImageInFrame") = False Then
            storage.CreateDirectory("ImageInFrame")
        End If


        myPhotoCamera = New PhotoCamera
        myVideoBrush.SetSource(myPhotoCamera)

        AddHandler myPhotoCamera.Initialized, Sub(cameraSender As Object, cameraArgs As CameraOperationCompletedEventArgs)
                                                  Try
                                                      If cameraArgs.Succeeded = False Then
                                                          Exit Sub
                                                      Else
                                                          Dim myResolution As IEnumerable(Of Size) = myPhotoCamera.AvailableResolutions
                                                          myPhotoCamera.Resolution = myResolution.First
                                                      End If
                                                  Catch
                                                      Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                                                    MessageBox.Show("カメラが起動するまでお待ちください。")
                                                                                                End Sub)

                                                  End Try

                                              End Sub

        Dim xmlFilePath As String = Path.Combine("ImageInFrame", "ImageList.xml")
        If storage.FileExists(xmlFilePath) = True Then
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
        Else
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = False
        End If

        AddHandler myPhotoCamera.CaptureImageAvailable, AddressOf myPhotoCamera_CaptureImageAvailable

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub myPhotoCamera_CaptureImageAvailable(sender As Object, e As ContentReadyEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        Dim filePath As String = Path.Combine("ImageInFrame", imageFileName)
        Dim xmlFilePath As String = Path.Combine("ImageInFrame", "ImageList.xml")


       
        Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                      Using myStream As IsolatedStorageFileStream = storage.CreateFile(filePath)
                                                          Dim myBuffer(bufferValue) As Byte
                                                          Dim myByteRead As Integer = -1
                                                          Do
                                                              myByteRead = e.ImageStream.Read(myBuffer, 0, myBuffer.Length)
                                                              myStream.Write(myBuffer, 0, myByteRead)
                                                          Loop While (myByteRead > 0)
                                                          e.ImageStream.Close()
                                                      End Using

                                                      Dim imageStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                                                      Using stream As IsolatedStorageFileStream = imageStorage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                                                          Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(stream)
                                                          ellipseImage.Source = imageSource
                                                      End Using

                                                      Dim myWriteableBitmap As WriteableBitmap
                                                      myWriteableBitmap = New WriteableBitmap(InkPresenter1, Nothing)
                                                      'myWriteableBitmap.Invalidate()
                                                      If imageStorage.FileExists(Path.Combine("ImageInFrame", imageFileName)) = True Then
                                                          imageStorage.DeleteFile(Path.Combine("ImageInFrame", imageFileName))
                                                      End If
                                                      Using Stream As IsolatedStorageFileStream = storage.CreateFile(Path.Combine("ImageInFrame", imageFileName))
                                                          System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, Stream, 480, 640, 0, 85)
                                                      End Using


                                                  End Sub)

        'XMLファイルの保存
        Dim xmlStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        If xmlStorage.FileExists(xmlFilePath) = False Then
            Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                      <思い出>
                                          <風景 記録日=<%= recordDate %>>
                                              <画像名><%= imageFileName %></画像名>
                                          </風景>
                                      </思い出>
            Using xmlStream As IsolatedStorageFileStream = xmlStorage.CreateFile(xmlFilePath)
            End Using


            If xmlStorage.FileExists(xmlFilePath) = True Then
                Using xmlwriter As StreamWriter = New StreamWriter(xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                    xmlwriter.Flush()
                    xmlwriter.Write(xmldoc.ToString)
                End Using
                Me.Dispatcher.BeginInvoke(Sub()
                                              MessageBox.Show("画像とXMLファイルを保存しました。")
                                              TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
                                          End Sub)
            End If
        Else
            Dim xmlStream As IsolatedStorageFileStream = xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Read)
            Using xmlreader As StreamReader = New StreamReader(xmlStream)

                Dim readXmldoc As String = xmlreader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim addXml As XElement = <風景 記録日=<%= recordDate %>>
                                             <画像名><%= imageFileName %></画像名>
                                         </風景>
                doc.Add(addXml)
                xmlStream.Close()

                If xmlStorage.FileExists(xmlFilePath) = True Then
                    Using xmlwriter As StreamWriter = New StreamWriter(storage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                        xmlwriter.Flush()
                        xmlwriter.Write(doc.ToString)
                        'xmlwriter.Close()
                        Me.Dispatcher.BeginInvoke(Sub()
                                                      MessageBox.Show("画像とXMLファイルを保存しました。")
                                                      TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
                                                  End Sub)
                    End Using
                End If
            End Using
         
        End If
    End Sub

    Private Sub GoShutter(sender As System.Object, e As EventArgs)

        If myPhotoCamera Is Nothing = False Then
            Try
                imageFileName = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
                recordDate = DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒")
                myPhotoCamera.CaptureImage()
            Catch
                Me.Dispatcher.BeginInvoke(Sub() MessageBox.Show("エラーが発生しましたが、データは保存されますのでご安心ください。"))
            End Try
        End If
    End Sub

    Private Sub GoIchiran(sender As Object, e As EventArgs)
        RemoveHandler myPhotoCamera.CaptureImageAvailable, AddressOf myPhotoCamera_CaptureImageAvailable
        myPhotoCamera = Nothing
        NavigationService.Navigate(New Uri("/DataIchiranPage.xaml", UriKind.Relative))
    End Sub
End Class
